import 'react-zlib-js';
import bwipjs from 'bwip-js';
import { Image } from 'expo-image';
import { useEffect, useState } from 'react';

type Props = {
  value: string
}

type DataIMG = {
  height: number,
  width: number,
  uri: string
}

export default function BarCode({value}: Props) {
  const [img, setImg] = useState<DataIMG>();

  useEffect(() => {
    bwipjs.toDataURL({
      bcid: 'code39',
      text: value,
    }, (err: any, data: DataIMG) => {
      if (err) {
        console.error(err);
      } else {
        setImg(data);
      }
    })
  }, [value]);

  if (!img) return null;

  return (
    <Image
      style={{
        height: img.height,
        width: img.width,
        backgroundColor: 'white'
    }}
      contentFit="fill"
      source={{ uri:img.uri }}
    />
  );

}
